From 67b20f477b7c556150df98c68fe604ad328c85ac Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 13 Nov 2019 14:50:07 -0500
Subject: [PATCH 55/78] FIXME: WIP on less LHS in paths (needs splitting)

---
 cover-letter.txt                                   |  88 +++--
 .../NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c |   2 +-
 .../analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-1.c | 144 +++----
 .../analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-2.c |   2 +-
 .../gcc.dg/analyzer/analyzer-verbosity-0.c         | 138 +++----
 .../gcc.dg/analyzer/analyzer-verbosity-1.c         | 198 +++++-----
 .../gcc.dg/analyzer/analyzer-verbosity-2.c         | 256 ++++++------
 gcc/testsuite/gcc.dg/analyzer/malloc-ipa-11.c      | 124 +++---
 .../gcc.dg/analyzer/malloc-ipa-8-double-free.c     | 221 ++++++-----
 .../gcc.dg/analyzer/malloc-ipa-8-unchecked.c       |  74 ++--
 .../gcc.dg/analyzer/malloc-macro-inline-events.c   |  36 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-paths-9.c     | 430 +++++++++++----------
 gcc/testsuite/gcc.dg/analyzer/setjmp-2.c           |  82 ++--
 gcc/testsuite/gcc.dg/analyzer/setjmp-3.c           | 128 +++---
 gcc/testsuite/gcc.dg/analyzer/setjmp-4.c           | 138 +++----
 gcc/testsuite/gcc.dg/analyzer/setjmp-5.c           |  80 ++--
 gcc/testsuite/gcc.dg/analyzer/setjmp-8.c           | 128 +++---
 gcc/testsuite/gcc.dg/analyzer/setjmp-9.c           | 128 +++---
 .../gcc.dg/plugin/diagnostic-path-format-default.c | 154 ++++----
 .../diagnostic-path-format-inline-events-1.c       | 154 ++++----
 .../diagnostic-path-format-inline-events-2.c       | 161 ++++----
 .../diagnostic-path-format-inline-events-3.c       | 161 ++++----
 .../gcc.dg/plugin/diagnostic-test-paths-2.c        |  34 +-
 gcc/tree-diagnostic-path.cc                        | 170 ++++----
 24 files changed, 1640 insertions(+), 1591 deletions(-)

diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c
index 5095285..096f164 100644
--- a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -Wno-analyzer-too-complex" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret -Wno-analyzer-too-complex" } */
 
 typedef unsigned char __u_char;
 typedef unsigned short int __u_short;
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-1.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-1.c
index 625f5b6..c5a99c9 100644
--- a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-1.c
@@ -1,5 +1,5 @@
 /* Taken from https://en.wikipedia.org/wiki/Setjmp.h  */
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <stdio.h>
 #include <setjmp.h>
@@ -28,79 +28,81 @@ int main() {
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |     __analyzer_dump_path ();
+      |     ^~~~~~~~~~~~~~~~~~~~~~~
   'main': event 1
-     |
-     |   NN | int main() {
-     |      |     ^~~~
-     |      |     |
-     |      |     (1) entry to 'main'
-     |
+    |
+    |   NN | int main() {
+    |      |     ^~~~
+    |      |     |
+    |      |     (1) entry to 'main'
+    |
   'main': event 2
-     |
-     |   NN |     if (!setjmp(buf))
-     |      |          ^~~~~~
-     |      |          |
-     |      |          (2) 'setjmp' called here
-     |
+    |
+    |   NN |     if (!setjmp(buf))
+    |      |          ^~~~~~
+    |      |          |
+    |      |          (2) 'setjmp' called here
+    |
   'main': events 3-5
-     |
-     |   NN |     if (!setjmp(buf))
-     |      |        ^
-     |      |        |
-     |      |        (3) following 'true' branch...
-     |   NN |         first();                // when executed, setjmp returned 0
-     |      |         ~~~~~~~
-     |      |         |
-     |      |         (4) ...to here
-     |      |         (5) calling 'first' from 'main'
-     |
-     +--> 'first': events 6-7
-             |
-             |   NN | void first() {
-             |      |      ^~~~~
-             |      |      |
-             |      |      (6) entry to 'first'
-             |   NN |     second();
-             |      |     ~~~~~~~~
-             |      |     |
-             |      |     (7) calling 'second' from 'first'
-             |
-             +--> 'second': events 8-9
-                      |
-                      |   NN | void second() {
-                      |      |      ^~~~~~
-                      |      |      |
-                      |      |      (8) entry to 'second'
-                      |   NN |     printf("second\n");         // prints
-                      |   NN |     longjmp(buf,1);             // jumps back to where setjmp was called - making setjmp now return 1
-                      |      |     ~~~~~~~~~~~~~~
-                      |      |     |
-                      |      |     (9) rewinding from 'longjmp' in 'second'...
-                      |
-     <----------------+
-     |
+    |
+    |   NN |     if (!setjmp(buf))
+    |      |        ^
+    |      |        |
+    |      |        (3) following 'true' branch...
+    |   NN |         first();                // when executed, setjmp returned 0
+    |      |         ~~~~~~~
+    |      |         |
+    |      |         (4) ...to here
+    |      |         (5) calling 'first' from 'main'
+    |
+    +--> 'first': events 6-7
+           |
+           |   NN | void first() {
+           |      |      ^~~~~
+           |      |      |
+           |      |      (6) entry to 'first'
+           |   NN |     second();
+           |      |     ~~~~~~~~
+           |      |     |
+           |      |     (7) calling 'second' from 'first'
+           |
+           +--> 'second': events 8-9
+                  |
+                  |   NN | void second() {
+                  |      |      ^~~~~~
+                  |      |      |
+                  |      |      (8) entry to 'second'
+                  |   NN |     printf("second\n");         // prints
+                  |   NN |     longjmp(buf,1);             // jumps back to where setjmp was called - making setjmp now return 1
+                  |      |     ~~~~~~~~~~~~~~
+                  |      |     |
+                  |      |     (9) rewinding from 'longjmp' in 'second'...
+                  |
+    <-------------+
+    |
   'main': event 10
-     |
-     |   NN |     if (!setjmp(buf))
-     |      |          ^~~~~~
-     |      |          |
-     |      |          (10) ...to 'setjmp' in 'main' (saved at (2))
-     |
+    |
+    |   NN |     if (!setjmp(buf))
+    |      |          ^~~~~~
+    |      |          |
+    |      |          (10) ...to 'setjmp' in 'main' (saved at (2))
+    |
   'main': events 11-13
-     |
-     |   NN |     if (!setjmp(buf))
-     |      |        ^
-     |      |        |
-     |      |        (11) following 'false' branch...
-     |......
-     |   NN |         printf("main\n");       // prints
-     |      |         ~~~~~~~~~~~~~~~~
-     |      |         |
-     |      |         (12) ...to here
-     |   NN | 
-     |   NN |     __analyzer_dump_path ();
-     |      |     ~~~~~~~~~~~~~~~~~~~~~~~
-     |      |     |
-     |      |     (13) here
-     |
+    |
+    |   NN |     if (!setjmp(buf))
+    |      |        ^
+    |      |        |
+    |      |        (11) following 'false' branch...
+    |......
+    |   NN |         printf("main\n");       // prints
+    |      |         ~~~~~~~~~~~~~~~~
+    |      |         |
+    |      |         (12) ...to here
+    |   NN | 
+    |   NN |     __analyzer_dump_path ();
+    |      |     ~~~~~~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (13) here
+    |
     { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-2.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-2.c
index a2ff27f..17a4228 100644
--- a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-setjmp-wikipedia-2.c
@@ -1,5 +1,5 @@
 /* Taken from https://en.wikipedia.org/wiki/Setjmp.h  */
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 #include <setjmp.h>
 #include <stdio.h>
 #include <stdlib.h>
diff --git a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-0.c b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-0.c
index 6293075..98200b3 100644
--- a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-0.c
+++ b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-0.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fanalyzer-verbosity=0" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret -fanalyzer-verbosity=0" } */
 
 #include <stdlib.h>
 
@@ -20,41 +20,43 @@ void test_1 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_1': event 1
-      |
-      |   NN |     calls_free_1 (ptr);
-      |      |     ^~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (1) calling 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': event 2
-                  |
-                  |   NN |   free (ptr);
-                  |      |   ^~~~~~~~~~
-                  |      |   |
-                  |      |   (2) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN |     calls_free_1 (ptr);
+    |      |     ^~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (1) calling 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': event 2
+           |
+           |   NN |   free (ptr);
+           |      |   ^~~~~~~~~~
+           |      |   |
+           |      |   (2) first 'free' here
+           |
+    <------+
+    |
   'test_1': events 3-4
-      |
-      |   NN |     calls_free_1 (ptr);
-      |      |     ^~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (3) returning to 'test_1' from 'calls_free_1'
-      |......
-      |   NN |     calls_free_1 (ptr);
-      |      |     ~~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (4) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': event 5
-                  |
-                  |   NN |   free (ptr);
-                  |      |   ^~~~~~~~~~
-                  |      |   |
-                  |      |   (5) second 'free' here; first 'free' was at (2)
-                  |
+    |
+    |   NN |     calls_free_1 (ptr);
+    |      |     ^~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (3) returning to 'test_1' from 'calls_free_1'
+    |......
+    |   NN |     calls_free_1 (ptr);
+    |      |     ~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (4) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': event 5
+           |
+           |   NN |   free (ptr);
+           |      |   ^~~~~~~~~~
+           |      |   |
+           |      |   (5) second 'free' here; first 'free' was at (2)
+           |
   { dg-end-multiline-output "" } */
 
 void calls_free_2 (void *ptr)
@@ -88,41 +90,43 @@ void test_2 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_2': event 1
-      |
-      |   NN |       calls_free_2 (ptr);
-      |      |       ^~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (1) calling 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': event 2
-                  |
-                  |   NN |   free (ptr);
-                  |      |   ^~~~~~~~~~
-                  |      |   |
-                  |      |   (2) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN |       calls_free_2 (ptr);
+    |      |       ^~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (1) calling 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': event 2
+           |
+           |   NN |   free (ptr);
+           |      |   ^~~~~~~~~~
+           |      |   |
+           |      |   (2) first 'free' here
+           |
+    <------+
+    |
   'test_2': events 3-4
-      |
-      |   NN |       calls_free_2 (ptr);
-      |      |       ^~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (3) returning to 'test_2' from 'calls_free_2'
-      |......
-      |   NN |       calls_free_2 (ptr);
-      |      |       ~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (4) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': event 5
-                  |
-                  |   NN |   free (ptr);
-                  |      |   ^~~~~~~~~~
-                  |      |   |
-                  |      |   (5) second 'free' here; first 'free' was at (2)
-                  |
+    |
+    |   NN |       calls_free_2 (ptr);
+    |      |       ^~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (3) returning to 'test_2' from 'calls_free_2'
+    |......
+    |   NN |       calls_free_2 (ptr);
+    |      |       ~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (4) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': event 5
+           |
+           |   NN |   free (ptr);
+           |      |   ^~~~~~~~~~
+           |      |   |
+           |      |   (5) second 'free' here; first 'free' was at (2)
+           |
   { dg-end-multiline-output "" } */
 
 // TODO: range cases
diff --git a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-1.c b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-1.c
index 32f3111..7e437bb 100644
--- a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-1.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fanalyzer-verbosity=1" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret -fanalyzer-verbosity=1" } */
 
 #include <stdlib.h>
 
@@ -20,56 +20,58 @@ void test_1 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_1': events 1-2
-      |
-      |   NN | void test_1 (void *ptr, int a, int b)
-      |      |      ^~~~~~
-      |      |      |
-      |      |      (1) entry to 'test_1'
-      |......
-      |   NN |     calls_free_1 (ptr);
-      |      |     ~~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (2) calling 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': events 3-4
-                  |
-                  |   NN | void calls_free_1 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (3) entry to 'calls_free_1'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (4) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN | void test_1 (void *ptr, int a, int b)
+    |      |      ^~~~~~
+    |      |      |
+    |      |      (1) entry to 'test_1'
+    |......
+    |   NN |     calls_free_1 (ptr);
+    |      |     ~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (2) calling 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': events 3-4
+           |
+           |   NN | void calls_free_1 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (3) entry to 'calls_free_1'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (4) first 'free' here
+           |
+    <------+
+    |
   'test_1': events 5-6
-      |
-      |   NN |     calls_free_1 (ptr);
-      |      |     ^~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (5) returning to 'test_1' from 'calls_free_1'
-      |......
-      |   NN |     calls_free_1 (ptr);
-      |      |     ~~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (6) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': events 7-8
-                  |
-                  |   NN | void calls_free_1 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (7) entry to 'calls_free_1'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (8) second 'free' here; first 'free' was at (4)
-                  |
+    |
+    |   NN |     calls_free_1 (ptr);
+    |      |     ^~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (5) returning to 'test_1' from 'calls_free_1'
+    |......
+    |   NN |     calls_free_1 (ptr);
+    |      |     ~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (6) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': events 7-8
+           |
+           |   NN | void calls_free_1 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (7) entry to 'calls_free_1'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (8) second 'free' here; first 'free' was at (4)
+           |
   { dg-end-multiline-output "" } */
 
 void calls_free_2 (void *ptr)
@@ -103,54 +105,56 @@ void test_2 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_2': events 1-2
-      |
-      |   NN | void test_2 (void *ptr, int a, int b)
-      |      |      ^~~~~~
-      |      |      |
-      |      |      (1) entry to 'test_2'
-      |......
-      |   NN |       calls_free_2 (ptr);
-      |      |       ~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (2) calling 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': events 3-4
-                  |
-                  |   NN | void calls_free_2 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (3) entry to 'calls_free_2'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (4) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN | void test_2 (void *ptr, int a, int b)
+    |      |      ^~~~~~
+    |      |      |
+    |      |      (1) entry to 'test_2'
+    |......
+    |   NN |       calls_free_2 (ptr);
+    |      |       ~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (2) calling 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': events 3-4
+           |
+           |   NN | void calls_free_2 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (3) entry to 'calls_free_2'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (4) first 'free' here
+           |
+    <------+
+    |
   'test_2': events 5-6
-      |
-      |   NN |       calls_free_2 (ptr);
-      |      |       ^~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (5) returning to 'test_2' from 'calls_free_2'
-      |......
-      |   NN |       calls_free_2 (ptr);
-      |      |       ~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (6) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': events 7-8
-                  |
-                  |   NN | void calls_free_2 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (7) entry to 'calls_free_2'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (8) second 'free' here
-                  |
+    |
+    |   NN |       calls_free_2 (ptr);
+    |      |       ^~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (5) returning to 'test_2' from 'calls_free_2'
+    |......
+    |   NN |       calls_free_2 (ptr);
+    |      |       ~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (6) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': events 7-8
+           |
+           |   NN | void calls_free_2 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (7) entry to 'calls_free_2'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (8) second 'free' here; first 'free' was at (4)
+           |
   { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-2.c b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-2.c
index 99a51fc..2c9e5da 100644
--- a/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/analyzer-verbosity-2.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fanalyzer-verbosity=2" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret -fanalyzer-verbosity=2" } */
 
 #include <stdlib.h>
 
@@ -20,67 +20,69 @@ void test_1 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_1': events 1-4
-      |
-      |   NN | void test_1 (void *ptr, int a, int b)
-      |      |      ^~~~~~
-      |      |      |
-      |      |      (1) entry to 'test_1'
-      |   NN | {
-      |   NN |   if (a)
-      |      |      ~
-      |      |      |
-      |      |      (2) following 'true' branch (when 'a != 0')...
-      |   NN |     calls_free_1 (ptr);
-      |      |     ~~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (3) ...to here
-      |      |     (4) calling 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': events 5-6
-                  |
-                  |   NN | void calls_free_1 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (5) entry to 'calls_free_1'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (6) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN | void test_1 (void *ptr, int a, int b)
+    |      |      ^~~~~~
+    |      |      |
+    |      |      (1) entry to 'test_1'
+    |   NN | {
+    |   NN |   if (a)
+    |      |      ~
+    |      |      |
+    |      |      (2) following 'true' branch (when 'a != 0')...
+    |   NN |     calls_free_1 (ptr);
+    |      |     ~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (3) ...to here
+    |      |     (4) calling 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': events 5-6
+           |
+           |   NN | void calls_free_1 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (5) entry to 'calls_free_1'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (6) first 'free' here
+           |
+    <------+
+    |
   'test_1': events 7-10
-      |
-      |   NN |     calls_free_1 (ptr);
-      |      |     ^~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (7) returning to 'test_1' from 'calls_free_1'
-      |   NN | 
-      |   NN |   if (b)
-      |      |      ~
-      |      |      |
-      |      |      (8) following 'false' branch (when 'b == 0')...
-      |......
-      |   NN |     calls_free_1 (ptr);
-      |      |     ~~~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (9) ...to here
-      |      |     (10) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
-      |
-      +--> 'calls_free_1': events 11-12
-                  |
-                  |   NN | void calls_free_1 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (11) entry to 'calls_free_1'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (12) second 'free' here; first 'free' was at (6)
-                  |
+    |
+    |   NN |     calls_free_1 (ptr);
+    |      |     ^~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (7) returning to 'test_1' from 'calls_free_1'
+    |   NN | 
+    |   NN |   if (b)
+    |      |      ~
+    |      |      |
+    |      |      (8) following 'false' branch (when 'b == 0')...
+    |......
+    |   NN |     calls_free_1 (ptr);
+    |      |     ~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (9) ...to here
+    |      |     (10) passing freed pointer 'ptr' in call to 'calls_free_1' from 'test_1'
+    |
+    +--> 'calls_free_1': events 11-12
+           |
+           |   NN | void calls_free_1 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (11) entry to 'calls_free_1'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (12) second 'free' here; first 'free' was at (6)
+           |
   { dg-end-multiline-output "" } */
 
 void calls_free_2 (void *ptr)
@@ -114,74 +116,76 @@ void test_2 (void *ptr, int a, int b)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_2': events 1-4
-      |
-      |   NN | void test_2 (void *ptr, int a, int b)
-      |      |      ^~~~~~
-      |      |      |
-      |      |      (1) entry to 'test_2'
-      |   NN | {
-      |   NN |   switch (a)
-      |      |   ~~~~~~
-      |      |   |
-      |      |   (2) following 'case 3:' branch...
-      |......
-      |   NN |     case 3:
-      |      |     ~~~~
-      |      |     |
-      |      |     (3) ...to here
-      |   NN |       calls_free_2 (ptr);
-      |      |       ~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (4) calling 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': events 5-6
-                  |
-                  |   NN | void calls_free_2 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (5) entry to 'calls_free_2'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (6) first 'free' here
-                  |
-      <-----------+
-      |
+    |
+    |   NN | void test_2 (void *ptr, int a, int b)
+    |      |      ^~~~~~
+    |      |      |
+    |      |      (1) entry to 'test_2'
+    |   NN | {
+    |   NN |   switch (a)
+    |      |   ~~~~~~
+    |      |   |
+    |      |   (2) following 'case 3:' branch...
+    |......
+    |   NN |     case 3:
+    |      |     ~~~~
+    |      |     |
+    |      |     (3) ...to here
+    |   NN |       calls_free_2 (ptr);
+    |      |       ~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (4) calling 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': events 5-6
+           |
+           |   NN | void calls_free_2 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (5) entry to 'calls_free_2'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (6) first 'free' here
+           |
+    <------+
+    |
   'test_2': events 7-10
-      |
-      |   NN |       calls_free_2 (ptr);
-      |      |       ^~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (7) returning to 'test_2' from 'calls_free_2'
-      |......
-      |   NN |   switch (b)
-      |      |   ~~~~~~
-      |      |   |
-      |      |   (8) following 'default:' branch...
-      |   NN |     {
-      |   NN |     default:
-      |      |     ~~~~~~~
-      |      |     |
-      |      |     (9) ...to here
-      |   NN |       calls_free_2 (ptr);
-      |      |       ~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (10) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
-      |
-      +--> 'calls_free_2': events 11-12
-                  |
-                  |   NN | void calls_free_2 (void *ptr)
-                  |      |      ^~~~~~~~~~~~
-                  |      |      |
-                  |      |      (11) entry to 'calls_free_2'
-                  |   NN | {
-                  |   NN |   free (ptr);
-                  |      |   ~~~~~~~~~~
-                  |      |   |
-                  |      |   (12) second 'free' here; first 'free' was at (6)
-                  |
+    |
+    |   NN |       calls_free_2 (ptr);
+    |      |       ^~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (7) returning to 'test_2' from 'calls_free_2'
+    |......
+    |   NN |   switch (b)
+    |      |   ~~~~~~
+    |      |   |
+    |      |   (8) following 'default:' branch...
+    |   NN |     {
+    |   NN |     default:
+    |      |     ~~~~~~~
+    |      |     |
+    |      |     (9) ...to here
+    |   NN |       calls_free_2 (ptr);
+    |      |       ~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (10) passing freed pointer 'ptr' in call to 'calls_free_2' from 'test_2'
+    |
+    +--> 'calls_free_2': events 11-12
+           |
+           |   NN | void calls_free_2 (void *ptr)
+           |      |      ^~~~~~~~~~~~
+           |      |      |
+           |      |      (11) entry to 'calls_free_2'
+           |   NN | {
+           |   NN |   free (ptr);
+           |      |   ~~~~~~~~~~
+           |      |   |
+           |      |   (12) second 'free' here; first 'free' was at (6)
+           |
   { dg-end-multiline-output "" } */
 
 // TODO: range cases
